' -------------------------------------------------------------------------
'       From the book Inside Active Directory, ISBN 0-201-61621-1
'       Copyright (C) 2002 by Addison-Wesley
'       Script by Sakari Kouti (see http://www.kouti.com)
' You have a royalty-free right to use, modify, reproduce and distribute
' this script (and/or any modified version) in any way you find useful,
' provided that you agree that Addison-Wesley or Sakari Kouti has no
' warranty, obligations or liability for the script. If you modify
' the script, you must retain this copyright notice.
' -------------------------------------------------------------------------
Option Explicit

'AccessMask
Const FILE_READ_DATA            = &H1    'file & pipe
Const FILE_LIST_DIRECTORY       = &H1    'folder
Const FILE_WRITE_DATA           = &H2    'file & pipe
Const FILE_ADD_FILE             = &H2    'folder
Const FILE_APPEND_DATA          = &H4    'file
Const FILE_ADD_SUBDIRECTORY     = &H4    'folder
Const FILE_CREATE_PIPE_INSTANCE = &H4    'named pipe
Const FILE_READ_EA              = &H8    'file & folder
Const FILE_WRITE_EA             = &H10    'file & folder
Const FILE_EXECUTE              = &H20    'file
Const FILE_TRAVERSE             = &H20    'folder
Const FILE_DELETE_CHILD         = &H40    'folder
Const FILE_READ_ATTRIBUTES      = &H80    'all
Const FILE_WRITE_ATTRIBUTES     = &H100    'all
Const DELETE                    = &H10000
Const READ_CONTROL              = &H20000
Const WRITE_DAC                 = &H40000
Const WRITE_OWNER               = &H80000
Const SYNCHRONIZE               = &H100000
Const ACCESS_SYSTEM_SECURITY    = &H1000000
Const GENERIC_ALL               = &H10000000
Const GENERIC_EXECUTE           = &H20000000
Const GENERIC_WRITE             = &H40000000
Const GENERIC_READ              = &H80000000

Const FULL_CONTROL = &H1F01FF  '14 permissions
Const MODIFY = &H1301BF  '11 permissions

'ACE flags
Const OBJECT_INHERIT_ACE                = &H1
Const CONTAINER_INHERIT_ACE             = &H2
Const NO_PROPAGATE_INHERIT_ACE          = &H4
Const INHERIT_ONLY_ACE                  = &H8
Const INHERITED_ACE                     = &H10
Const SUCCESSFUL_ACCESS_ACE_FLAG        = &H40
Const FAILED_ACCESS_ACE_FLAG            = &H80

'ACE types
Const ACCESS_ALLOWED_ACE_TYPE           = &H0
Const ACCESS_DENIED_ACE_TYPE            = &H1
Const SYSTEM_AUDIT_ACE_TYPE             = &H2
Const SYSTEM_ALARM_ACE_TYPE             = &H3
Const ACCESS_ALLOWED_COMPOUND_ACE_TYPE  = &H4
Const ACCESS_ALLOWED_OBJECT_ACE_TYPE    = &H5
Const ACCESS_DENIED_OBJECT_ACE_TYPE     = &H6
Const SYSTEM_AUDIT_OBJECT_ACE_TYPE      = &H7
Const SYSTEM_ALARM_OBJECT_ACE_TYPE      = &H8

'Flags
Const ADS_OBJECT_TYPE_PRESENT           = &H1
Const ADS_INHERITED_OBJECT_TYPE_PRESENT = &H2

Dim objFS, objSecDesc, objDACL, objACE, objADsSec

'Create the Folder
'---------------------------
Set objFS = CreateObject("Scripting.FileSystemObject")
Call objFS.CreateFolder("D:\ACEDemo")

'Create the ACE - modify permission for a the subtree
'-----------------------------------------------------------------
Set objACE = CreateObject("AccessControlEntry")
objACE.Trustee	= "Red.Baron@sanao.com"
objACE.AccessMask	= MODIFY
objACE.AceFlags	= OBJECT_INHERIT_ACE + _
                      CONTAINER_INHERIT_ACE
objACE.AceType	= ACCESS_ALLOWED_ACE_TYPE

'Add the ACE
'-----------------
Set objADsSec = CreateObject("ADsSecurity")

Set objSecDesc = objADsSec.GetSecurityDescriptor("FILE://D:\ACEDemo")
Set objDACL = objSecDesc.DiscretionaryAcl

Call objDACL.AddAce(objACE)
objSecDesc.DiscretionaryAcl = objDACL
Call objADsSec.SetSecurityDescriptor(objSecDesc)
